PPATH - Prime Path
The ministers of the cabinet were quite upset by the
message from the Chief of Security stating that they
would all have to change the four-digit room numbers
on their offices.
— It is a matter of security to change such things
every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good
reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also
a prime. You will just have to paste four new
digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the
first digit to an 8, then the number will read 8033
which is not a prime!
— I see, being the prime minister you cannot stand
having a non-prime number on your door even for a
few seconds.
— Correct! So I must invent a scheme for going from
1033 to 8179 by a path of prime numbers where
only one digit is changed from one prime to the
next prime.
Now, the minister of finance, who had been eavesdropping,
intervened.
— No unnecessary expenditure, please! I happen to
know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to
minimize the cost. You don't know some very cheap
software gurus, do you?
— In fact, I do. You see, there is this programming
contest going on...
Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033 1733 3733 3739 3779 8779 8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Example
Input: 3 1033 8179 1373 8017 1033 1033 Output: 6 7 0
hide comments
Abhishek Naik:
2016-01-24 14:29:24
One important thing that I noticed - The next number in the sequence can be smaller than the previous one. For e.g., my accepted program gives the following output for the 1st test case (printed in the reverse order due to backtracking):
|
|
Deepak :
2016-01-19 14:41:34
nice one..AC in one go. |
|
anandrohit:
2016-01-15 12:09:25
Importance of < & <=
|
|
lakshay_v06:
2016-01-14 15:41:50
Gr8 ques! Basic graph theory + sieve ! Done in 0.00! :D |
|
abhinav_rai:
2015-12-17 23:00:29
Cool Problem. Made me remember bfs and heights along with sieve and how to check for single digit change. Indeed great problem!! |
|
KAUSHAL AGRAWAL:
2015-12-08 23:23:15
First problem of Graph Theory, solved in one go Last edit: 2016-02-09 20:02:56 |
|
rocode0001:
2015-12-05 13:51:33
first problem of bfs.....14hours....right in two go!!!!!! |
|
kejriwal:
2015-11-03 18:47:00
Amazing problem :D !! |
|
Ankush Sharma:
2015-10-15 20:38:17
Nothing is impossible :) !! |
|
:.Mohib.::
2015-09-17 21:49:19
Awsm que..!! |
Added by: | overwise |
Date: | 2007-10-02 |
Time limit: | 2s |
Source limit: | 50000B |
Memory limit: | 1536MB |
Cluster: | Cube (Intel G860) |
Languages: | All except: ERL JS-RHINO NODEJS PERL6 VB.NET |
Resource: | ACM ICPC NWERC 2006 |